import java.awt.*;

class Door extends Panel
{
  static final Color green = new Color(0, 255, 0);
  static final Color black = new Color(0, 0, 0);

  Panel left, middle, right;
  Elevator elevator;
  int pos;

  void setColors()
  {
    if(elevator.pos == pos)
      {
	if(left.getBackground() != green) left.setBackground(green);
	Color c = (elevator.isOpened() ? black : green);
	if(middle.getBackground() != c) middle.setBackground(c);
	if(right.getBackground() != green) right.setBackground(green);
      }
    else 
      {
	Color c = Level.background(pos);
	if(left.getBackground() != c) left.setBackground(c);
	if(middle.getBackground() != c) middle.setBackground(c);
	if(right.getBackground() != c) right.setBackground(c);
      }
  }

  synchronized void reset()
  {
    setColors();
  }

  synchronized void tick()
  {
    setColors();
  }

  Door(Elevator elevator, int pos)
  { 
    this.pos = pos;
    this.elevator = elevator;

    GridBagLayout l = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setLayout(l);
    c.fill = GridBagConstraints.BOTH;
    c.ipadx = c.ipady = 0;
    c.weighty = 1.0;

    Panel p = new Panel();
    c.weightx = 1.0;
    l.setConstraints(p, c);
    add(p);

    left = new Panel();
    c.weightx = 1.0;
    l.setConstraints(left, c);
    add(left);

    middle = new Panel();
    c.weightx = 8.0;
    l.setConstraints(middle, c);
    add(middle);

    right = new Panel();
    c.weightx = 1.0;
    l.setConstraints(right, c);
    add(right);

    reset();
  }
}
