class LiveController extends Controller
{
  int target[];

  private boolean isRegisteredTarget(int t)
  {
    boolean res;
    int i;

    for(i = 0, res = false; !res && i < Simulation.LEVELS; i++)
      res = (target[i] == t);
    
    return res;
  }

  private void registerTarget(int t)
  {
    int i;

    for(i = 0; target[i] != Simulation.LEVELS; i++)
      ;
    
    target[i] = t;
  }

  private void shift()
  {
    for(int i = 1; i < Simulation.LEVELS; i++)
      target[i - 1] = target[i];
    
    target[Simulation.LEVELS - 1] = Simulation.LEVELS;
  }

  LiveController(Simulation simulation)
  {
    super(simulation);
    target = new int[Simulation.LEVELS];
    reset();
  }

  void reset()
  {
    for(int i = 1; i < Simulation.LEVELS; i++)
      target[i] = Simulation.LEVELS;
  }

  void tick()
  {
    if(target[0] < Simulation.LEVELS)
      {
	if(target[0] == simulation.elevator.pos)
	  {
	    if(simulation.elevator.isOpened()) 
	      {
		simulation.level[target[0]].requested = false;
		simulation.elevator.setOpened(false);
		shift();
		if(Simulation.DEBUG)
		  {
		    System.out.print("LiveController:             target ");
		    System.out.println(
		      target[0] == Simulation.LEVELS ? 
		        "none" :
			"" + target[0]);
		  }

	      }
	    else if(simulation.elevator.stopped) 
	      {
		simulation.elevator.setOpened(true);
	      }
	    else simulation.elevator.stopped = true;
	  }
	else
	  {
	    simulation.elevator.stopped = false;
	    simulation.elevator.upward = (target[0] > simulation.elevator.pos);
	  }
      }

    boolean no_target = (target[0] == Simulation.LEVELS);

    for(int i = 0; i < Simulation.LEVELS; i++)
      if(simulation.level[i].requested && !isRegisteredTarget(i))
        registerTarget(i);

    if(Simulation.DEBUG && no_target && target[0] < Simulation.LEVELS)
      System.out.println("LiveController:             target " + target[0]);
  }
}
