class MinMaxController extends Controller
{
  boolean upward;
  int min, max;

  MinMaxController(Simulation simulation)
  {
    super(simulation);
    reset();
  }

  private void recalculate()
  {
    int old_target;

    old_target = target();
    max = min = Simulation.LEVELS;

    for(int i = 0; i < Simulation.LEVELS; i++)
      if(simulation.level[i].requested)
	{
	  if(min == Simulation.LEVELS || i < min) min = i;
	  if(max == Simulation.LEVELS || i > max) max = i;
	}
    
    if(min != Simulation.LEVELS)
      {
        if(upward && simulation.elevator.pos > max) upward = false;
        else if(!upward && simulation.elevator.pos < min) upward = true;
      }
      
    if(Simulation.DEBUG && old_target != target())
      {
	System.out.print("MinMaxController:           target ");
	if(target() == Simulation.LEVELS) System.out.println("none");
	else System.out.println("" + target());
      }
  }

  private int target()
  {
    return upward ? max : min;
  }

  void reset()
  {
    min = max = Simulation.LEVELS;
    upward = true;
  }

  void tick()
  {
    int p;

    if(min < Simulation.LEVELS)
      {
	if(simulation.level[p = simulation.elevator.pos].requested)
	  {
	    if(simulation.elevator.stopped) 
	      {
		if(simulation.elevator.isOpened()) 
		  {
		    simulation.level[p].requested = false;
		    simulation.elevator.setOpened(false);
		    recalculate();
		  }
		else simulation.elevator.setOpened(true);
	      }
	    else simulation.elevator.stopped = true;
	  }
	else
	  {
	    simulation.elevator.stopped = false;
	    simulation.elevator.upward = upward;
	  }
      }
    else recalculate();
  }
}
