class SafeController extends Controller
{
  int target;

  SafeController(Simulation simulation)
  {
    super(simulation);
    reset();
  }

  void reset()
  {
    target = Simulation.LEVELS;
  }

  void tick()
  {
    if(target < Simulation.LEVELS)
      {
	if(target == simulation.elevator.pos)
	  {
	    if(simulation.elevator.isOpened()) 
	      {
		simulation.level[target].requested = false;
		simulation.elevator.setOpened(false);
		target = Simulation.LEVELS;
		if(Simulation.DEBUG)
		  System.out.println(
		    "SafeController:             target none");
	      }
	    else if(simulation.elevator.stopped) 
	      {
		simulation.elevator.setOpened(true);
	      }
	    else simulation.elevator.stopped = true;
	  }
	else
	  {
	    simulation.elevator.stopped = false;
	    simulation.elevator.upward = (target > simulation.elevator.pos);
	  }
      }
    else
      {
	for(target = 0; target < Simulation.LEVELS; target++)
	  if(simulation.level[target].requested) break;

	if(Simulation.DEBUG)
	  {
	    if(target < Simulation.LEVELS)
	      System.out.println(
		"SafeController:             target " + target);
	  }
      }
  }
}
