class SimpleController extends Controller
{
  /* Only used for debugging output.
   */
  int old_target;

  SimpleController(Simulation simulation)
  {
    super(simulation);
    reset();
  }

  void reset()
  {
    old_target = Simulation.LEVELS;
  }

  void tick()
  {
    int target;

    for(target = 0; target < Simulation.LEVELS; target++)
      if(simulation.level[target].requested) break;
    
    if(target < Simulation.LEVELS)
      {
	if(target == simulation.elevator.pos)
	  {
	    if(simulation.elevator.isOpened()) 
	      {
		simulation.level[target].requested = false;
		simulation.elevator.setOpened(false);
	      }
	    else if(simulation.elevator.stopped) 
	      {
		simulation.elevator.setOpened(true);
	      }
	    else simulation.elevator.stopped = true;
	  }
	else
	  {
	    simulation.elevator.stopped = false;
	    simulation.elevator.upward = (target > simulation.elevator.pos);
	  }
      }
    else simulation.elevator.setOpened(simulation.elevator.isOpened());
    
    if(Simulation.DEBUG && old_target != target) 
      {
	if(target == Simulation.LEVELS)
	  {
	    System.out.println("SimpleController:           target none");
	  }
	else System.out.println("SimpleController:           target " + target);
      }
    
    old_target = target;
  }
}
