import java.awt.event.*;

class TimerRunnable implements Runnable {
  ActionListener listener;
  long milliseconds;
  boolean finished;

  TimerRunnable(long m, ActionListener l) {
    listener = l;
    milliseconds = m;
  }

  public void run()
  {
    while(!finished)
      {
	try { Thread.sleep(milliseconds); } catch(InterruptedException e) { }

	if(finished) break;

	ActionEvent e;
	e = new ActionEvent(this, ActionEvent.ACTION_PERFORMED, null);
	listener.actionPerformed(e);
      }
  }

  public synchronized void setFinished() { finished = true; }
}
